# -*- Perl -*-
#
# X-Rust Color Definitions and Subroutines
#
# $Id: xrust_color.pl,v 1.2 1996/09/06 02:16:03 ruefenac Exp $

use strict;
#use vars qw(%FILTER $globals %COLORS @caller_queues);
use vars qw($COLOR_SELECTED $MW);

%COLORS = (
		 'Menu'                  => { 
					     'foreground' => 'black', 
					     'background' => 'grey85'
					    },
		 'Labels'                => {
					     'foreground' => 'black',
					     'background' => 'grey85'
					    },
		 'Default'               => {
					     'foreground' => 'black',
					     'background' => 'grey85'
					    },
		 'Radial'                => {
					     'foreground' => 'black',
					     'background' => 'grey85'
					    },
		 'Buttons'               => {
					     'foreground' => 'black', 
					     'background' => 'grey85'
					    },
		 'Request Headers'       => { 
					     'foreground' => 'black', 
					     'background' => 'grey85'
					    },
		 'Status Bar'            => { 
					     'foreground' => 'red3', 
					     'background' => 'grey85'
					    },
		 'Query Index Header'    => { 
					     'foreground' => 'black', 
					     'background' => 'grey85'
					    },
		 'Query Index Selected'  => { 
					     'foreground' => 'black', 
					     'background' => '#667fcdd2aa7c'
					    },
		 'Query Index Current'   => { 
					     'foreground' => 'black', 
					     'background' => '#66e9cdd20000'
					    },
		 'Query Index'           => {
					     'foreground' => 'black', 
					     'background' => 'LightGoldenrod3'
					    }
		);

sub colorize_request {

    my $text = shift;
    
    if ($CONFIGURE{'colorize'}) {

	$text->tagAdd('header','0.0','17.0');
#	$text->tagConfigure('header',
#			    -foreground => $COLORS{'Request Headers'}->{'foreground'},
#			    -background => $COLORS{'Request Headers'}->{'background'}
#			   );
    }
}

sub color_editor {

    my $CW = $MW->Toplevel;

    my $list_frame = $CW->Frame;
    $list_frame->pack(-side => 'left');

    my $list_scroll = $list_frame->Scrollbar;
    $list_scroll->pack(-side => 'left', -fill => 'y');
    my $listbox = $list_frame->Listbox(
				       -yscrollcommand => [$list_scroll => 'set'],
				       -width => 20,
				       -height => 16
				      );
    $listbox->pack(-side=>'left');
    $list_scroll->configure(-command => [$listbox => 'yview']);

    $listbox->bind('<ButtonPress-1>' =>
		   sub {
		       $COLOR_SELECTED = $_[0]->get('active');
		   }
		  );

    my $cref = $CW->ColorEditor;
    $cref->configure(
		     -display_status => 0,
              	     -command => [\&color_callback,$cref]
		    );

    $listbox->insert(0, keys %COLORS);

    $cref->Show;

}

sub color_callback {    
    
    my($objref, $type, $color) = @_;

    $objref->{'Status'}->title("Configure $type");
    my $widget;
    my $reset = !defined($color);

    $COLORS{$COLOR_SELECTED}->{$type} = $color;
    &colorize_widgets('single',$type,$COLOR_SELECTED);

} 

sub colorize_widgets {
    my $style = shift;
    my(@widgets,@types,$widget,$type,$tag,@tag_info,$color);

    if ($style eq 'single') {
	$type = shift;
	$style = shift;
    }

    if ($type ne '') {
	push(@types,$type);
    } else {
	@types = keys %{$COLORS{$style}};
    }

    foreach (@{$COLORS{$style}->{'widgets'}}) {
	if ($_ ne "") {
	    push (@widgets, $_);
	}
    }

    foreach $type (@types) {
	next if ($type  eq 'widgets');
	$color = $COLORS{$style}->{$type};
	my $reset = !defined($color);
	foreach $widget (@widgets) {
	    eval {$color = ($widget->configure("-\L${type}"))[3]} if $reset;
	    eval {$widget->configure("-\L${type}" => $color)};
	}

	if (defined $COLORS{$style}->{'tags'}) {
	    my @tag_info = @{$COLORS{$style}->{'tags'}};
	    my $i;
	    while ($#tag_info >= 0) {
		$tag = shift(@tag_info);
		$widget = shift(@tag_info);
		$color = $COLORS{$style}->{$type};
		if ($tag ne "") {
		    if ($widget->depth  == 1) {
			eval {
			    $widget->tag($tag,
					 -background => 'black',
					 -foreground => 'white'
					);
			}
		    } else {
			eval {
			    $widget->tag('configure', $tag,
					 -$type => $color
					);
			}
		    }
		}
	    }
	}
    }
}


1;
